

forvalues lo = 4/4 {
di `lo'
forvalues wo = 4/4 {
di `wo'
foreach vars of numlist 2 10 {



di `vars'

loc long = 10^`lo'
loc wide = 10^`wo'
*loc vars = 2
loc lout = 0.1
loc reps = 1

loc toto = `long'*`wide'
set more off
matrix TimesAccum=J(`reps',25,0) /* This matrix will store results */

forvalues rep = 1/`reps' {


*** 1) Generate Data
drop _all
set obs `toto'
** Variables
forvalues var = 1/`vars' {
	gen x`var'= rnormal(0)
	}
** Fixed Effects
* Indicators
gen hhid = floor((_n-1)/`wide')
gen ttid = _n-1-hhid*`wide'
** Drop a fraction of observations;
gen out= uniform()
sort out
drop if _n<`lout'*`toto'
* Effects
gen hhef = rnormal(0)
gen ttef = rnormal(0)
bysort hhid: replace hhef = hhef[1]
gen hid = 1
replace hid = hid[_n-1] + 1*(hhid[_n-1]~=hhid[_n]) if _n>1
bysort ttid: replace ttef = ttef[1]
gen tid = 1
replace tid = tid[_n-1] + 1*(ttid[_n-1]~=ttid[_n]) if _n>1


** Dependent Variable
gen y = hhef + ttef + rnormal(0)
forvalues var = 1/`vars' {
	replace y= y + x`var'
	}



*** 2) Run Our Method
/*
timer clear
capture matrix drop twoWayB twoWayC twoWayAinvDDDH twoWayinvHH twoWayinvDD
capture matrix drop twoWayB twoWayA twoWayCinvHHDH twoWayinvHH twoWayinvDD
timer on 1
twowayset hid tid
timer off 1
matrix dir
timer on 2
projvar y x*, p(w_)
timer off 2
timer on 3
reg w_y w_x*, noc robust
timer off 3
capture matrix drop twoWayB twoWayC twoWayAinvDDDH twoWayinvHH twoWayinvDD
capture matrix drop twoWayB twoWayA twoWayCinvHHDH twoWayinvHH twoWayinvDD
drop w_*
*** 3) Run reg2hdfe

timer on 4
*reg2hdfe y x*, id1(tid) id2(hid)
timer off 4
*/

*** 4) Run a2reg

timer on 5
*a2reg y x*, individual(tid) unit(hid)
timer off 5
** save results
timer list
matrix Times =(r(t1), r(t2), r(t3), r(t4), r(t5) ) 

*** 5) Run felsdvreg
timer on 6
felsdvreg y x*, ivar(hhid) jvar(tid) feff(aux0) peff(aux1) xb(aux2) res(aux3) mover(aux4) mnum(aux5) pobs(aux6) group(aux7)
timer off 6

** save results
matrix Times2 = J(1,20,0) /*(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)*/
timer list
forvalues t = 1/20{
    matrix Times2[1,`t']=r(t`t')
}

*** 6) Collect and save results

** Colect
matrix TimesAccum[`rep',1]=[Times]
drop _all
di `long'
}




svmat TimesAccum, names(time)
ren time1 OwnInv
ren time2 OwnPro
ren time3 OwnReg

ren time4 reg2hdfe
ren time5 a2reg

forvalues t = 6/25{
	loc t5=`t'-5
    gen felsdvreg`t5'=.
	
	}
di `long'
gen longi = `long'
gen widet = `wide'
gen vars = `vars'
gen lout = `lout'
** Save
append using Times.dta
save Times.dta, replace

}
}
}
